;=================================================================
; Project Name	: SysLink Control Example
; Version		: 1.0
; Compiler		: Masm32 package v9.0
; IDE			: RadAsm v2.2.1.2
; Tested		: XP
; Date			: 01-04-2008
; Author		: Rudy Rooroh (asmsoft@hotmail.com)
;=================================================================


.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include SysLink.inc

.code

start:

	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	mov		icex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov		icex.dwICC, ICC_LINK_CLASS  
	invoke	InitCommonControlsEx, addr icex
	invoke	DialogBoxParam, hInstance, IDD_DIALOG1, NULL, addr DlgProc, NULL
	invoke	ExitProcess, 0


DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_INITDIALOG
		
		invoke	CreateWindowEx, 0, addr SysLinkClass, addr TestLinkText, WS_VISIBLE or WS_CHILD,\
		        8, 20, 350, 24, hWnd, NULL, hInstance, NULL
		mov		hTextSysLink, eax
		
		invoke	CreateWindowEx, 0, addr SysLinkClass, addr SysLinkText, WS_VISIBLE or WS_CHILD,\
		        8, 60, 350, 24, hWnd, NULL, hInstance, NULL
		mov		hSysLink, eax
		
	.elseif uMsg==WM_NOTIFY
		
		mov		edx, lParam
		mov		eax, [edx+NMHDR.hwndFrom]
		
		.if eax==hTextSysLink
			.if [edx+NMHDR.code]==NM_CLICK
				invoke	ucCmp, addr TestLinkID1, addr [edx+NMLINK.item.szID]
				.if eax!=0
					invoke	MessageBox, hWnd, addr szClickMe1, addr AppName, MB_OK
				.else
					invoke	MessageBox, hWnd, addr szClickMe2, addr AppName, MB_OK
				.endif
			.endif
		.elseif eax==hSysLink
			.if [edx+NMHDR.code]==NM_CLICK
				invoke	ConvertUnicode2String, addr [edx+NMLINK.item.szUrl], addr TextBuff
				invoke	ShellExecute, hWnd, addr szOpen, addr TextBuff, 0, 0, SW_SHOWNORMAL
			.endif
		.endif
		
	.elseif uMsg==WM_CLOSE
		
		invoke	EndDialog, hWnd, 0
		
	.else
		
		mov		eax, FALSE
		ret
		
	.endif
	
	mov		eax, TRUE
	ret

DlgProc endp


ConvertUnicode2String proc uses esi edi lpstrsrc:DWORD, lpstrdst:DWORD
	
	mov		esi, lpstrsrc
	mov		edi, lpstrdst
	mov		ax, word ptr [esi]
	.while ax!=0
		mov		byte ptr [edi], al
		inc		edi
		add		esi, 2
		mov		ax, word ptr [esi]
	.endw
	mov		byte ptr [edi], 0
	ret

ConvertUnicode2String endp


end start
